;
; Hugi Compo #30
;  Submitted by:  Sniper  (Ben Lunt)
;       Contact:  benlunt@fysnet.net
;          Date:  19 Sept 2023
;          Size:  150 bytes
;
; Assembled with NBASM 00.26.80
;  https://www.fysnet.net/newbasic.htm
;

.model tiny
.code
.486
            org 100h
            
            mov  fs,ax
            
            ; assumes ax = 0 on startup
            mov  al,13h
            int  10h

            ; set the video area and set al = 0
            mov  ax,0A000h
            mov  es,ax
            
            ; assumes al = 0 from above
            ; assumes bx = 0 on startup
            ; assumes ch = 0 on startup
            mov  dx,03C9h
            mov  cl,11
pal:        xchg bx,ax
            out  dx,al
            xchg bx,ax
            out  dx,al
            out  dx,al
            add  bl,6
            loop pal
            
            ; 'rules' state:
            ;  "and also except entries that look alike"
            ; so we can fudge the original 'inc' here
            mov  cl,(4 * 9)
            mov  bp,offset rects
            mov  si,bp
init:       and  byte [si],07
            inc  si
            loop init
            
            push ax
              
mainloop:     lea  ax,[bp + 36]
              cmpxchg si,bp
              
              ; I beleive this is suppose to be
              ;  di = ([si] * 20) + ([si+1] * 6420)
              ; but since there are no rules, the
              ;  following works just fine
              lodsw
              imul di,ax,6420
              
              ; wait for the vertical retrace to start,
              ;  then wait for it to finish
              ; (we are suppose to wait for the start of the
              ;  vertical retrace, but since there are no rules :-)
              ; (dh = 03 from above)
              mov  dl,0DAh    ; VGA input status register
wait_start:   in   al,dx
              test al,8        ; bit 3 = 1 = in vertical retrace, 0 = not in vertical retrace
              jz   short wait_start
              
; empty the square
              xor  ax,ax
              mov  cl,20
              call square
              
              ; assumes ah = 0
              mov  al,10
              sub  al,[si]
              imul bx,ax,321
              add  di,bx
              
; fill square
              ; assumes ah = 0
              ; assumes ch = 0
              lodsb
              mov  cl,al
              add  cl,al
              call square
              
              in   al,60h
              dec  al
              jz   short ende
              
              ; [si] = 0 = decrease, not 0 = increase 
              ;  (first time can be 0 to 7, every other time will be either 0 or 1)
              dec  si
              lodsw     ; ah = 0 = decrease, not 0 = increase 
              
              or   ah,ah
              je   short decrease
              
              inc  ax
              cmp  al,11
              jb  short cont0
              
decrease:     dec  ax
              setz ah
cont0:        mov  [si-2],ax

            pop  ax
            inc  ax
            push ax
              cmp  al,10
              jne  short mainloop
              
              mov  ax,fs:[046Ch]
              and  ax,070Fh
              mov  [si-4],ax
              
              jmp  short mainloop
              
ende:       pop  ax
            mov  ax,0003h
            int  10h
            ret

; al = color
; cx = width/height
; di = top left corner 
square:       mov  bx,cx
              push di
@@:             pusha
                  mov  cx,bx
                  rep
                    stosb
                popa
                add  di,320
                loop @b
              pop  di
              ret


; rect
;  x
;  y
;  size
;  dir
rects       dup (9 * 4),?

.end
